%% Copyright (c) 1991,1994,1995 by Carnegie Mellon University %%
%% Copyright (c) 1994,1995 by AT&T Bell Laboratories          %%
%% Copyright (c) 1995,1996 by the University of Pennsylvania		%%

%% For information about the distributaion, copying, and modification	%%
%% of this software, please read the file COPYING located in the root	%%
%% directory of this distribnutaion. If you did not receive the file	%%
%% COPYING write to Philip Wickline at the address below.		%%

%% This program is distributed in the hope that it will be useful but	%%
%% WITHOUT ANY WARRANTY; without even the implied warranty of		%%
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file	%%
%% COPYING for more details.						%%

%% For information about the structure of the Terzo lambdaProlog	%%
%% implementation, see the file src/README in this distribution. Please	%%
%% address any questions about this code or the Terzo lambdaProlog	%%
%% implementation to Philip Wickline at <philipw@saul.cis.upenn.edu>.	%%

%% Authors: Amy Felty <felty@research.att.com>                %%
%%          Frank Pfenning <fp@cs.cmu.edu>                    %%
%%          Philip Wickline <philipw@saul.cis.upenn.edu>      %%

module Logicals.

kind	o		type.


type	true		o.


type	','		o -> o -> o.
infixr  ','             2.

type	'&'		o -> o -> o.
infixr	'&'		3.

type	';'		o -> o -> o.
infixl	';'             1.


type	'=>'		o -> o -> o.
infixr	'=>'            4.

type	':-'		o -> o -> o.
infixl	':-'            0.
%% ``p :- q'' is an alternative concrete syntax for the implication
%% ``q => p'', but ':-' will not be used on unparsing.


type	pi		(A -> o) -> o.

type	sigma		(A -> o) -> o.


